# AUTOGENERATED! DO NOT EDIT! File to edit: ../../nbs/api/08_quantification_01_strategies.ipynb.

# %% auto 0
__all__ = ['CountFeaturesInWholeAreaROIsStrat']

# %% ../../nbs/api/08_quantification_01_strategies.ipynb 2
from typing import Tuple, List, Dict
from pathlib import Path

import cc3d

from .specs import QuantificationObject, QuantificationStrategy
from ..configs import DefaultConfigs
from .. import utils

# %% ../../nbs/api/08_quantification_01_strategies.ipynb 4
class CountFeaturesInWholeAreaROIsStrat(QuantificationStrategy):
    
    """
    Strategy description
    """

    @property
    def dropdown_option_value_for_gui(self):
        return 'Count all features in all area ROIs'
    
    @property
    def default_configs(self):
        default_values = {}
        valid_types = {}
        default_configs = DefaultConfigs(default_values = default_values, valid_types = valid_types)
        return default_configs
        
    @property
    def widget_names(self):
        return {}

    @property
    def descriptions(self):
        return {}
    
    @property
    def tooltips(self):
        return {}
    
    
    def run(self, processing_object: QuantificationObject, strategy_configs: Dict) -> QuantificationObject:
        quantification_results = {}
        for area_roi_id in processing_object.segmentations_per_area_roi_id.keys():
            _, feature_count = cc3d.connected_components(processing_object.segmentations_per_area_roi_id[area_roi_id], return_N=True)
            quantification_results[area_roi_id] = feature_count
        processing_object = self._add_quantification_results_to_database(quantification_object = processing_object, results = quantification_results)
        return processing_object


    def _add_strategy_specific_infos_to_updates(self, updates: Dict) -> Dict:
        return updates
